unit apci34s;

interface

uses
  Windows, Messages, SysUtils, Forms, apci34w;

const
  szTitle = 'Sample';
  szP34   = 'aPCI-P34';

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
		procedure ResultMessage(szBuf: String);
		procedure ErrorMessage(wLogSlot: Word);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
	wLogSlot:	Word;								// ޲̘_ۯĔԍi[
	Ri:				TAPCI34RESOURCE;		// ؿ
	dwDLLVer, dwDriverVer: DWord;
	dwSwVal:	DWord;							// ۰ذ̒l
	cbDat:		Byte;
	bResult:	Boolean;						// 
	szBuf:		String;
  hWnd:     THandle;
  InitArg:  DWord;
  md:       TAPCI34MODE;
begin
	//-------------------------------------------------
	// apci34.dll ̎gp錾
	//-------------------------------------------------
	if Apci34wDllOpen() = False then begin
		ErrorMessage(APCI34_SLOT_AUTO);
		Exit;											// apci34.dll ۰ނɎs܂
	end;
	//-------------------------------------------------
	// ްޮݔԍ\
	// aPCI-P34 DLL,ײްްޮݔԍ擾
	//-------------------------------------------------
	if Apci34wGetVersion(dwDLLVer, dwDriverVer) = False then begin
		ErrorMessage(APCI34_SLOT_AUTO);
		Exit;
	end;

	szBuf := Format('GetVersion'#10 +
									'DLL Version'#09+ ': %0.8xH'#10 +
									'Driver Version'#09+ ': %0.8xH',
									[dwDLLVer, dwDriverVer]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aPCI-P34̎gp錾
	//-------------------------------------------------
	wLogSlot := APCI34_SLOT_AUTO;				// gp޲T܂B
  hWnd    := 0;
  InitArg := 0;
	bResult := Apci34wCreate(wLogSlot, hWnd, $0, InitArg);	// ꍇA̎޲̘_ۯĔԍi[܂B
	if bResult = False then begin
		ErrorMessage(APCI34_SLOT_AUTO);   // ޲܂B
		Exit;
	end;
	szBuf := Format('aPCI-P34 Created'#10#10 +
								  'LogSlot: %2d'
									,[wLogSlot]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// ؿ۰ذ̒l擾
	//-------------------------------------------------
	if Apci34wGetResource(wLogSlot, Ri) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	if Apci34wGetSwitchValue(wLogSlot, dwSwVal) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Board Name'#09  + ': %s'#10 +
									 'IO Base Address'#09  + ': %04xH - %04xH'#10 +
									 'IRQ'#09#09     + ': %d'#10 +
									 'Switch'#09#09   + ': %01xH',
									 [szP34,
										Ri.dwIOPortBase[2],
										Ri.dwIOPortBase[2] + Ri.dwIOPortLength[2] - 1,
										Ri.dwIRQRegisters[1],
										dwSwVal]);
	ResultMessage(szBuf);
  //-------------------------------------------------
	// IN01/IN02/IN09/IN10 ̊荞ݐݒ
	//-------------------------------------------------
  md.dwIn01 := APCI34_IRQ_DISABLE;    // 荞݋֎~
  md.dwIn02 := APCI34_IRQ_DISABLE;    // 荞݋֎~
  md.dwIn09 := APCI34_IRQ_DISABLE;    // 荞݋֎~
  md.dwIn10 := APCI34_IRQ_DISABLE;    // 荞݋֎~
  if Apci34wIrqMode(wLogSlot, @md) = False then
  begin
    ErrorMessage(wLogSlot);
    Halt;
  end;
	//-------------------------------------------------
	// Port 1 ɔCӂްo
	//-------------------------------------------------
	cbDat := Byte($AA);
	if Apci34wOutPort(wLogSlot, APCI34_PORT_1, cbDat) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Port 1 փf[^o'#10 +
					 				 'Port 1 Out Data: %02xH',
									 [cbDat]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// Port 1 ްǂݍ
	//-------------------------------------------------
	cbDat := Byte($00);
	if Apci34wInPort(wLogSlot, APCI34_PORT_1, cbDat) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Port 1 f[^'#10 +
									 'Port 1 In Data: %02xH',
									 [cbDat]);
	ResultMessage(szBuf);
  //-------------------------------------------------
	// IN01/IN02/IN09/IN10 ̊荞ݐݒ
	//-------------------------------------------------
  //md.dwIn01 := APCI34_IRQ_DISABLE;
  //md.dwIn02 := APCI34_IRQ_DISABLE;
  //md.dwIn09 := APCI34_IRQ_DISABLE;
  //md.dwIn10 := APCI34_IRQ_DISABLE;
  //if Apci34wIrqMode(wLogSlot, @md) = False then
  //begin
  //  ErrorMessage(wLogSlot);
  //  Halt;
  //end;
  //-------------------------------------------------
	// aPCI-P34̎gpJ
	//-------------------------------------------------
	if Apci34wClose(wLogSlot) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	ResultMessage('aPCI-P34 Closed');
	//-------------------------------------------------
	// apci34.dll ̎gpJ
	//-------------------------------------------------
	if Apci34wDllClose() = False then begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;
	end;
end;

//============================================================================
// ʂ\
//============================================================================
procedure TForm1.ResultMessage(szBuf: String);
begin
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//============================================================================
// װүނ\
//============================================================================
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	szBuf: String;
begin
	dwRes := Apci34wGetLastError(wLogSlot);
	case dwRes of
		APCI34_ERR_SYSTEM:
			szBuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);
		APCI34_ERR_WRAPDLL:
    	szBuf := 'DLL Load error';
		else
			szBuf := Format('aPCI-P34 error'#10#10'Error code: %08xH',[dwRes]);
  end;
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
