/*============================================================================
//	apci34s.c
//
//	aPCI-P34
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 2004/03/11
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "apci34w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR sz34[]  = _T("aPCI-P34");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);

/*============================================================================
//	۸т̊Jn
//===========================================================================*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WORD  wLogSlot;				// ޲̘_ۯĔԍi[
	APCI34RESOURCE Ri;			// ؿ
	DWORD dwDLLVer, dwDriverVer;
	DWORD dwSwVal;				// ۰ذ̒l
	BYTE  cbDat;
	BOOL  bResult;				// 
	TCHAR szBuf[256];
	APCI34MODE md;

	/*-----------------------------------------------------------------------*/
	// apci34.dll ̎gp錾
	if (Apci34wDllOpen() == FALSE){
		ErrorMessage(APCI34_SLOT_AUTO);
		return 1;				// apci34.dll ۰ނɎs܂
	}

	/*-----------------------------------------------------------------------*/
	// ްޮݔԍ\
	// aPCI-34 DLL,ײްްޮݔԍ擾
	if (Apci34wGetVersion(&dwDLLVer, &dwDriverVer) == FALSE){
		ErrorMessage(APCI34_SLOT_AUTO);
		return 1;
	}
	wsprintf(szBuf, _T("GetVersion\n")
					_T("DLL    Version\t: %08lxh\n")
					_T("Driver Version\t: %08lxh"),
					dwDLLVer,
					dwDriverVer);
	ResultMessage(szBuf);

	/*-----------------------------------------------------------------------*/
	// aPCI-34̎gp錾
	wLogSlot = APCI34_SLOT_AUTO;			// gp޲T܂
	bResult = Apci34wCreate(&wLogSlot, NULL, 0, NULL);		// ꍇA̎޲̘_ۯĔԍi[܂
	if (bResult == FALSE){					// ޲܂B
		ErrorMessage(APCI34_SLOT_AUTO);
		return 1;
	}
	wsprintf(szBuf, _T("aPCI-P34 Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);
	ResultMessage(szBuf);

	/*-----------------------------------------------------------------------*/
	// ؿ۰ذ̒l擾
	if (Apci34wGetResource(wLogSlot, &Ri) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	if (Apci34wGetSwitchValue(wLogSlot, &dwSwVal) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf, _T("Board Name  \t: %s\n")
					_T("IO Base Address  \t: %04Xh - %04Xh\n")
					_T("IRQ         \t\t: %d\n")
					_T("Switch      \t: %Xh\n"),
					sz34,
					Ri.dwIOPortBase[1],
					Ri.dwIOPortBase[1] + Ri.dwIOPortLength[1] - 1,
					Ri.dwIRQRegisters[0],
					dwSwVal);
	ResultMessage(szBuf);

	/*-----------------------------------------------------------------------*/
	// IN01/IN02/IN09/IN10 ̊荞ݐݒ
	md.dwIn01 = APCI34_IRQ_DISABLE;			// 荞݋֎~
	md.dwIn02 = APCI34_IRQ_DISABLE;			// 荞݋֎~
	md.dwIn09 = APCI34_IRQ_DISABLE;			// 荞݋֎~
	md.dwIn10 = APCI34_IRQ_DISABLE;			// 荞݋֎~
	if (Apci34wIrqMode(wLogSlot, &md) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}

	/*-----------------------------------------------------------------------*/
	// Port 1 ɔCӂްo
	cbDat = (BYTE)0xAA;
	if (Apci34wOutPort(wLogSlot, APCI34_PORT_1, cbDat) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf, _T("Port 1 փf[^o\n")
					_T("Port 1 Out Data: %02xh"),
					 cbDat);
	ResultMessage(szBuf);

	/*-----------------------------------------------------------------------*/
	// Port 1 ްǂݍ
	cbDat = (BYTE)0x00;
	if (Apci34wInPort(wLogSlot, APCI34_PORT_1, &cbDat) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf, _T("Port 1 f[^\n")
					_T("Port 1 In Data: %02xh"),
					 cbDat);
	ResultMessage(szBuf);

	/*-----------------------------------------------------------------------*/
	// IN01/IN02/IN09/IN10 ̊荞ݐݒ
	//md.dwIn01 = APCI34_IRQ_DISABLE;			// 荞݋֎~
	//md.dwIn02 = APCI34_IRQ_DISABLE;			// 荞݋֎~
	//md.dwIn09 = APCI34_IRQ_DISABLE;			// 荞݋֎~
	//md.dwIn10 = APCI34_IRQ_DISABLE;			// 荞݋֎~
	//if (Apci34wIrqMode(wLogSlot, &md) == False){
	//	ErrorMessage(wLogSlot);
	//	return 1;
	//}

	/*-----------------------------------------------------------------------*/
	// aPCI-34̎gpJ
	if (Apci34wClose(wLogSlot) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("aPCI-34 Closed"));

	/*-----------------------------------------------------------------------*/
	// apci34.dll ̎gpJ
	if (Apci34wDllClose() == FALSE){
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;
	}
	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// װүނ\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Apci34wGetLastError(wLogSlot);
	TCHAR szBuf[50];

	switch (dwRes){
		case APCI34_ERR_SYSTEM:
			wsprintf(szBuf, _T("System error\n\n")
							_T("Error code: %08lxh"),
							GetLastError());
			break;
		case APCI34_ERR_WRAPDLL:
			wsprintf(szBuf, _T("DLL Load error"));
			break;
		default:
			wsprintf(szBuf, _T("aPCI-P34 error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}
	MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
}
